#include "LinearCamera.hpp"

#include <cmath>

#include <GL/glew.h>

#include "../../Utils/MathUtils.hpp"

void LinearCamera :: apply()
{
    glLoadIdentity();
    gluLookAt(position.x,position.y,position.z,
              direction.x,direction.y,direction.z,
              up.x,up.y,up.z);
}

bool LinearCamera :: update(unsigned int actualTime)
{
    if ( startTime == 0 )
    {
        startTime = actualTime;
        return true;
    }

    unsigned int time = actualTime - startTime;

    if ( time > msTime )
    {
        return false;
    }

    this->position = MathUtils::lerp(positionStart,positionEnd,time/(float)msTime);
    this->direction = MathUtils::lerp(interestPointStart,interestPointEnd,time/(float)msTime);

    return true;
}
