#ifndef __LINEARCAMERA_HPP__
#define __LINEARCAMERA_HPP__

#include "GLUCamera.hpp"

#include "../../Types/Vector3.hpp"

class LinearCamera : public GLUCamera
{
    private:

        Vector3f positionStart;
        Vector3f positionEnd;

        Vector3f interestPointStart;
        Vector3f interestPointEnd;

        unsigned int startTime;
        unsigned int msTime;


    public:

        LinearCamera(const Vector3f& positionStart, const Vector3f& positionEnd, const Vector3f& interestPointStart, const Vector3f& interestPointEnd, const Vector3f& up, unsigned int msTime)
            :GLUCamera(positionStart,interestPointStart,up),positionStart(positionStart),positionEnd(positionEnd),
             interestPointStart(interestPointStart),interestPointEnd(interestPointEnd),
             startTime(0),msTime(msTime) {}

        void apply();
        bool update(unsigned int actualTime);

        unsigned int getMsTime() { return msTime; }
};

#endif
