#include "RotatingCamera.hpp"

#include <cmath>

#include <GL/glew.h>

#include "../../Utils/MathUtils.hpp"

void RotatingCamera :: apply()
{
    glLoadIdentity();
    gluLookAt(position.x,position.y,position.z,
              direction.x,direction.y,direction.z,
              up.x,up.y,up.z);
}

void RotatingCamera :: update()
{
    position.x = direction.x - sin(MathUtils::degToRan(angle))*distance;
    position.y = distance;
    position.z = direction.z - cos(MathUtils::degToRan(angle))*distance;

    angle += moveStep;
}
