#ifndef __TOPDOWNCAMERA_HPP__
#define __TOPDOWNCAMERA_HPP__

#include "GLUCamera.hpp"

#include "../../NEngine/Controllers/InputManager.hpp"

class TopDownCamera : public GLUCamera
{
    private:

        float moveStep;

    public:

        TopDownCamera(const Vector3f& position, float moveStep):GLUCamera(position, Vector3f(1,-1,0), Vector3f(0,1,0)),moveStep(moveStep) {}

        void moveLeft()
        {
            position.z -= moveStep;
        }

        void moveRight()
        {
            position.z += moveStep;
        }

        void moveUp()
        {
            position.x += moveStep;
        }

        void moveDown()
        {
            position.x -= moveStep;
        }

        void update(InputManager::ArrowsDirection directions);
};

#endif
