#ifndef __FRAMEBUFFER_HPP__
#define __FRAMEBUFFER_HPP__

#include <exception>
#include <string>

#include <GL/glew.h>

class RenderBuffer;

class FrameBufferException : public std::exception
{
    private:
        std::string message;

    public:
        FrameBufferException(const std::string& message):message(message) {}
        virtual ~FrameBufferException()throw() {}

        virtual const char* what() const throw()
        {
            return message.c_str();
        }
};

class FrameBuffer
{
    private:

        GLuint fid;

    public:

        FrameBuffer();
        ~FrameBuffer();

        void bind(const GLenum target);
        static void unbind(const GLenum target);

        void attach(const GLenum target, const GLenum attachmentPoint, const GLuint textureId);
        void attach(const GLenum target, const GLenum attachmentPoint, const RenderBuffer& renderBuffer);

        void validate(const GLenum target);
};

#endif
