#ifndef __LINERENDERRER_HPP__
#define __LINERENDERRER_HPP__

#include <vector>

#include "../Types/Vector3.hpp"
#include "../Types/Vector4.hpp"

struct Point
{
    Vector3f position;
    Colour4 colour;

    Point():position(),colour() {}
    Point(Vector3f position, Colour4 colour):position(position),colour(colour) {}
};

class LineRenderer
{
    private:
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

    public:
        LineRenderer() {}

        void addLine(const Point& p1, const Point& p2);
        void addLines(const std::vector<Point>& listPoints);
        void addLines(const std::vector<Point>& listPoints, const std::vector<unsigned int> listIndices);

        void clear() { vertices.clear() ; indices.clear(); }

        void draw(unsigned int lineSize = 4);

        unsigned int getNbPoints() { return vertices.size(); }
        unsigned int getNbIndices() { return indices.size(); }
};

#endif
