#include "RenderBuffer.hpp"

#include <iostream>

#include "../Utils/GLUtils.hpp"

RenderBuffer :: RenderBuffer()
{
    glGenRenderbuffers(1, &rid);
    std::cout << "New RenderBuffer id: " << rid << std::endl;

    if ( rid == 0 )
    {
        throw RenderBufferException("RenderBuffer id is 0");
    }

    GLUtils::checkError("glGenRenderbuffers");

    std::cout << "RenderBuffer created" << std::endl;
}

RenderBuffer :: ~RenderBuffer()
{
    glDeleteRenderbuffersEXT(1, &rid);
    std::cout << "deleted created" << std::endl;
}

void RenderBuffer :: create(const GLenum target, const GLenum format, const GLsizei width, const GLsizei height)
{
    glBindRenderbuffer(target,rid);
    glRenderbufferStorage(target, format, width, height);

    GLUtils::checkError("glRenderbufferStorage");
    glBindRenderbuffer(target,0);
}

void RenderBuffer :: bind(const GLenum target)
{
    glBindRenderbuffer(target,rid);
    GLUtils::checkError("glBindRenderbuffer");
}

void RenderBuffer :: unbind(const GLenum target)
{
    glBindRenderbuffer(target,0);
}
