#ifndef __RENDERBUFFER_HPP__
#define __RENDERBUFFER_HPP__

#include <exception>
#include <string>

#include <GL/glew.h>

#include "FrameBuffer.hpp"

class RenderBufferException : public std::exception
{
    private:
        std::string message;

    public:
        RenderBufferException(const std::string& message):message(message) {}
        virtual ~RenderBufferException()throw() {}

        virtual const char* what() const throw()
        {
            return message.c_str();
        }
};

class RenderBuffer
{
    private:

        GLuint rid;

        GLuint getRID()const { return rid; }

    public:

        RenderBuffer();
        ~RenderBuffer();

        void bind(const GLenum target);
        static void unbind(const GLenum target);

        void create(const GLenum target, const GLenum format, const GLsizei width, const GLsizei height);

        friend void FrameBuffer::attach(const GLenum target, const GLenum attachmentPoint, const RenderBuffer& renderBuffer);
};

#endif
