#include "ScreenQuad.hpp"

#include <GL/glew.h>

#include "../3D/Texture.hpp"
#include "../NEngine/Window.hpp"

#include "../Utils/GLUtils.hpp"

const float vquad[] = { 1, 1, 0, 1, 0, 0, 1, 0 };
const float tquad[] = { 1, 1, 0, 1, 0, 0, 1, 0 };

void ScreenQuad :: draw(const Texture& t, const Window& w)
{
    glViewport(0, 0, w.getWidth(), w.getHeight());

    glMatrixMode(GL_PROJECTION);
    glPushMatrix();

    glLoadIdentity();
    gluOrtho2D(0,1, 0, 1);

    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();
    glDisable(GL_DEPTH_TEST);


    glEnable(GL_TEXTURE_2D);
    t.bind();

    glBegin(GL_QUADS);
            {
                glTexCoord2f(1, 1);  glVertex2f(1,1);
                glTexCoord2f(0, 1);  glVertex2f(0,1);
                glTexCoord2f(0, 0);  glVertex2f(0,0);
                glTexCoord2f(1, 0);  glVertex2f(1,0);
            }glEnd();

/*

    glEnableClientState(GL_VERTEX_ARRAY);
    glEnableClientState(GL_TEXTURE_COORD_ARRAY);

    // Assign our data to OpenGL
    glVertexPointer(2, GL_FLOAT, 0, vquad);
    glTexCoordPointer(2, GL_FLOAT, 0, tquad);

    glDrawArrays(GL_QUADS,0, 4);
    GLUtils::checkError("glDrawArrays");

    glDisableClientState(GL_TEXTURE_COORD_ARRAY);
    glDisableClientState(GL_VERTEX_ARRAY);
*/
    t.unbind();
    glDisable(GL_TEXTURE_2D);

    glEnable(GL_DEPTH_TEST);
    glMatrixMode( GL_PROJECTION );
    glPopMatrix();
    glMatrixMode( GL_MODELVIEW );
    glPopMatrix();
}
