#ifndef __TEXTURE_HPP__
#define __TEXTURE_HPP__

#include <string>

#include <GL/glew.h>

#include "../Types/Vector4.hpp"

class Texture
{
    private:

        GLuint tid;

        void createID();
        void setParameters();

    public:

        Texture(const std::string& fileName);
        Texture(const unsigned int width, const unsigned height);
        Texture(const unsigned int width, const unsigned int height, const Colour4& c);
        ~Texture();

        void bind()const;
        static void unbind();

        GLuint getID() { return tid; }
};

#endif
