#ifndef __BEZIER_HPP__
#define __BEZIER_HPP__

template <typename T>
class Bezier
{
    private:

        T p1;
        T p2;
        T p3;
        T p4;

    public:
        Bezier(const T& p1,
               const T& p2,
               const T& p3,
               const T& p4):p1(p1),p2(p2),p3(p3),p4(p4) {}

        T get(float f)
        {
            float inv_f = 1-f;
            float inv_f2 = (1-f) * (1-f);

            return p1 * inv_f2 * inv_f + p2 * 3 * inv_f2 * f + p3 * 3 * inv_f * f * f + p4 * f * f * f;
        }
};

#endif
