#ifndef __CUBE_HPP__
#define __CUBE_HPP__

#include "../3D/LineRenderer.hpp"

#include "../Types/Vector3.hpp"

class Cube
{
    private:
        Vector3f position;
        Vector3f rotation;

        LineRenderer renderer;

        float offset;

        bool active;

    public:
        Cube(Vector3f position, Vector3f rotation, Colour3 colour, float scale=1, float offset=0);

        void draw();
        void update();

        void setActive(bool newState) { active = newState; }
        bool getActive() { return active; }
};

#endif
