#include "Font.hpp"

#include <GL/gl.h>

#include "../3D/LineRenderer.hpp"

#include "../Types/Vector3.hpp"
#include "../Types/Vector4.hpp"

Font :: Font(const Colour4& colour)
{
    {

        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.0f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.25f,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(0.25f,0,0.5),
                           colour));

        indices.push_back(0);
        indices.push_back(2);
        indices.push_back(1);
        indices.push_back(2);

        indices.push_back(3);
        indices.push_back(4);

        letters['a'] = new LineRenderer();
        letters['a']->addLines(vertices,indices);
    }

    {

        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,0.5),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(3);

        indices.push_back(0);
        indices.push_back(2);
        indices.push_back(1);
        indices.push_back(3);
        indices.push_back(4);
        indices.push_back(5);

        letters['b'] = new LineRenderer();
        letters['b']->addLines(vertices,indices);
    }

    {

        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,1),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(0);
        indices.push_back(2);
        indices.push_back(1);
        indices.push_back(3);

        letters['c'] = new LineRenderer();
        letters['c']->addLines(vertices,indices);
    }

    {

        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.3f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.3f,0,1),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(0);
        indices.push_back(2);
        indices.push_back(1);
        indices.push_back(3);
        indices.push_back(2);
        indices.push_back(3);

        letters['d'] = new LineRenderer();
        letters['d']->addLines(vertices,indices);
    }

    {

        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,0.5),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(0);
        indices.push_back(3);
        indices.push_back(1);
        indices.push_back(4);
        indices.push_back(2);
        indices.push_back(5);

        letters['e'] = new LineRenderer();
        letters['e']->addLines(vertices,indices);
    }

    {

        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,0.5),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(3);
        indices.push_back(2);
        indices.push_back(4);

        letters['f'] = new LineRenderer();
        letters['f']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.1f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.1f,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(-0.1f,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(-0.1f,0,0.8),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);
        indices.push_back(3);
        indices.push_back(4);
        indices.push_back(4);
        indices.push_back(5);

        letters['g'] = new LineRenderer();
        letters['g']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5f,0,0.5f),
                           colour));
        vertices.push_back(Point(Vector3f(0.5f,0,0.5),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(3);
        indices.push_back(4);
        indices.push_back(5);

        letters['h'] = new LineRenderer();
        letters['h']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(0,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0,0,1),
                           colour));

        indices.push_back(0);
        indices.push_back(1);

        letters['i'] = new LineRenderer();
        letters['i']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(0.3,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.3,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.3,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.3,0,0.5),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);

        letters['j'] = new LineRenderer();
        letters['j']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(3);
        indices.push_back(2);
        indices.push_back(4);

        letters['k'] = new LineRenderer();
        letters['k']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);

        letters['l'] = new LineRenderer();
        letters['l']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);
        indices.push_back(3);
        indices.push_back(4);

        letters['m'] = new LineRenderer();
        letters['m']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);

        letters['n'] = new LineRenderer();
        letters['n']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);
        indices.push_back(3);
        indices.push_back(0);

        letters['o'] = new LineRenderer();
        letters['o']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,0.5),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);
        indices.push_back(3);
        indices.push_back(4);

        letters['p'] = new LineRenderer();
        letters['p']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0,0,0.5),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);
        indices.push_back(3);
        indices.push_back(0);
        indices.push_back(3);
        indices.push_back(4);

        letters['q'] = new LineRenderer();
        letters['q']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);
        indices.push_back(3);
        indices.push_back(4);
        indices.push_back(4);
        indices.push_back(5);

        letters['r'] = new LineRenderer();
        letters['r']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);
        indices.push_back(3);
        indices.push_back(4);
        indices.push_back(4);
        indices.push_back(5);

        letters['s'] = new LineRenderer();
        letters['s']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.0,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0,0,1),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(3);

        letters['t'] = new LineRenderer();
        letters['t']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);

        letters['u'] = new LineRenderer();
        letters['u']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);

        letters['v'] = new LineRenderer();
        letters['v']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0,0,0.5),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);
        indices.push_back(3);
        indices.push_back(4);

        letters['w'] = new LineRenderer();
        letters['w']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));

        indices.push_back(0);
        indices.push_back(2);
        indices.push_back(1);
        indices.push_back(3);

        letters['x'] = new LineRenderer();
        letters['x']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0,0,0.5),
                           colour));

        indices.push_back(0);
        indices.push_back(3);
        indices.push_back(1);
        indices.push_back(3);
        indices.push_back(2);
        indices.push_back(3);

        letters['y'] = new LineRenderer();
        letters['y']->addLines(vertices,indices);
    }

    {
        std::vector<Point> vertices;
        std::vector<unsigned int> indices;

        vertices.push_back(Point(Vector3f(-0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,1),
                           colour));
        vertices.push_back(Point(Vector3f(-0.5,0,0),
                           colour));
        vertices.push_back(Point(Vector3f(0.5,0,0),
                           colour));

        indices.push_back(0);
        indices.push_back(1);
        indices.push_back(1);
        indices.push_back(2);
        indices.push_back(2);
        indices.push_back(3);

        letters['z'] = new LineRenderer();
        letters['z']->addLines(vertices,indices);
    }
}

Font :: ~Font()
{
    for ( std::map<char, LineRenderer*>::iterator itPFont = letters.begin() ; itPFont != letters.end() ; ++itPFont)
    {
        delete itPFont->second;
    }
}

void Font :: drawText(const Vector3f& position, const std::string& text, float scale)
{
    glPushMatrix();

    glTranslatef(position.x,position.y,position.z);
    glRotatef(180,0,1,0);
    glScalef(scale,scale,scale);

    for ( unsigned int i = 0 ; i < text.length() ; i++ )
    {
        if ( text[i] != ' ' )
        {
            getLetterRenderer(text[i])->draw(8);
        }

        glTranslatef(1.5,0,0);
    }

    glPopMatrix();
}

void Font :: drawText2(const Vector3f& position, const std::string& text, float scale)
{
    glPushMatrix();

    glTranslatef(position.x,position.y,position.z);
    glRotatef(270,0,1,0);
    glScalef(scale,scale,scale);

    for ( unsigned int i = 0 ; i < text.length() ; i++ )
    {
        if ( text[i] != ' ' )
        {
            getLetterRenderer(text[i])->draw(8);
        }

        glTranslatef(1.5,0,0);
    }

    glPopMatrix();
}

LineRenderer* Font :: getLetterRenderer(const char letter)
{
    return letters[tolower(letter)];
}
