#ifndef __FONT_HPP__
#define __FONT_HPP__

#include <map>
#include <string>

#include "../Types/Vector3.hpp"
#include "../Types/Vector4.hpp"

class LineRenderer;

class Font
{
    private:

        std::map<char , LineRenderer*> letters;

    public:
        Font(const Colour4& colour);
        ~Font();

        void drawText(const Vector3f& position, const std::string& text, float scale);
        void drawText2(const Vector3f& position, const std::string& text, float scale);

        LineRenderer* getLetterRenderer(const char letter);
};

#endif
