#include "Particules5.hpp"

#include <cmath>
#include <vector>

#include <GL/glew.h>

#include "../Types/Vector4.hpp"
#include "../Types/Vector3.hpp"

Particules5 :: Particules5(const Vector3f& startPosition, const Colour4& colour, const unsigned int nbParticules, float offset):startPosition(startPosition),startColour(colour.r*0.3,colour.g*0.3,colour.b*0.3,colour.a),livingParticules(0),counter(0),offset(offset)
{
    particules.reserve(nbParticules);
}

void Particules5 :: draw()
{
    glEnableClientState(GL_VERTEX_ARRAY);
    glEnableClientState(GL_COLOR_ARRAY);

    // Assign our data to OpenGL
    glVertexPointer(3, GL_FLOAT, sizeof(Particule) , &particules[0].position.x);
    glColorPointer(4, GL_FLOAT, sizeof(Particule), &particules[0].colour.r);

    glPointSize(3);
    glDrawArrays(GL_POINTS,0, livingParticules);

    glDisableClientState(GL_COLOR_ARRAY);
    glDisableClientState(GL_VERTEX_ARRAY);
}

void Particules5 :: update()
{
    for ( unsigned int i = 0 ; i < livingParticules ; i++ )
    {
        if ( particules[i].life > 200 )
        {
            particules[i] = particules[livingParticules-1];
            livingParticules--;
            // Death
        }
        else
        {
            particules[i].life ++;
            particules[i].position.y -=0.002f;
            particules[i].colour.a -=0.005f;
        }
    }

    if ( livingParticules < particules.capacity())
    {
        particules[livingParticules].position = startPosition + Vector3f(sinf(counter) + counter, 1 + cosf(counter*2+offset), sinf(counter+offset)+offset  + counter) + Vector3f(sinf(counter+offset),0,0);
        particules[livingParticules].colour = startColour;
        particules[livingParticules].living = true;
        particules[livingParticules].life = 0;
        livingParticules++;
    }

    counter+=0.03;
}
