#include "Scroller.hpp"

#include <GL/glew.h>

#include "Font.hpp"
#include "../3D/LineRenderer.hpp"

void Scroller :: draw(float scale)
{
    float zCounter = position.z;

    glPushMatrix();


    glTranslatef(position.x,position.y,position.z);
    glScalef(scale,scale,scale);
    for ( unsigned int i = 0 ; i < text.length() ; i++ )
    {
        if ( position.z + zCounter < 40 && position.z + zCounter > -40 )
        {
            if ( text[i] != ' ' )
            {
                pFont->getLetterRenderer(text[i])->draw(8);
            }
        }

        glTranslatef(0,0,-1.5);

        zCounter -= 1.5;
    }

    glPopMatrix();
}

void Scroller :: update(void)
{
    position.z += 0.035f;
    if (position.z > 200 )
    {
        position.z = -100;
    }
}
