#ifndef __SPHERE_HPP__
#define __SPHERE_HPP__

#include "../3D/LineRenderer.hpp"

#include "../Types/Vector3.hpp"

class Sphere
{
    private:
        Vector3f position;
        Vector3f rotation;

        LineRenderer renderer;

        float offset;

        bool active;

    public:
        Sphere(Vector3f position, Vector3f rotation, Colour3 colour, float size, unsigned int nbPpL, float offset = 0);

        void draw();
        void update();

        void setActive(bool newState) { active = newState; }
        bool getActive() { return active; }
};

#endif
