#include "Star.hpp"

#include <vector>

#include <GL/glew.h>

#include "../3D/LineRenderer.hpp"

#include "../Types/Vector3.hpp"

Star :: Star(Vector3f position, Vector3f rotation, Colour3 colour):position(position),rotation(rotation)
{
    std::vector<Point> points;

    points.push_back(Point(Vector3f(0.5,0,0.5),
                           colour));
    points.push_back(Point(Vector3f(0.5,0.5,1),
                           colour));
    points.push_back(Point(Vector3f(0,0.66,0.33),
                           colour));
    points.push_back(Point(Vector3f(1,0.66,0.33),
                           colour));


    points.push_back(Point(Vector3f(0.5,1,0.5),
                           colour));
    points.push_back(Point(Vector3f(0.5,0.5,0),
                           colour));
    points.push_back(Point(Vector3f(0,0.33,0.66),
                           colour));
    points.push_back(Point(Vector3f(1,0.33,0.66),
                           colour));

    std::vector<unsigned int> indices;

    indices.push_back(0);
    indices.push_back(1);
    indices.push_back(0);
    indices.push_back(2);
    indices.push_back(0);
    indices.push_back(3);
    indices.push_back(1);
    indices.push_back(2);
    indices.push_back(1);
    indices.push_back(3);
    indices.push_back(2);
    indices.push_back(3);

    indices.push_back(4);
    indices.push_back(5);
    indices.push_back(4);
    indices.push_back(6);
    indices.push_back(4);
    indices.push_back(7);
    indices.push_back(5);
    indices.push_back(6);
    indices.push_back(5);
    indices.push_back(7);
    indices.push_back(6);
    indices.push_back(7);

    renderer.addLines(points,indices);
}

void Star::draw()
{
    glPushMatrix();

    glTranslatef(position.x, position.y, position.z);

    glRotatef(rotation.x, 1,0,0);
    glRotatef(rotation.y, 0,1,0);
    glRotatef(rotation.z, 0,0,1);

    renderer.draw();

    glPopMatrix();
}

void Star :: update()
{
    rotation.x += 0.1f;
}
