#include "SceneManager.hpp"

#include <cassert>

#include "Scene.hpp"

SceneManager :: SceneManager():currentScene(0),grid(100,100,1.5f)
{

}

SceneManager :: ~SceneManager()
{
    for ( std::vector<Scene*>::iterator itPScene = scenes.begin() ; itPScene != scenes.end() ; ++itPScene )
    {
        delete (*itPScene);
    }

    scenes.clear();
}

void SceneManager :: addScene(Scene* pScene)
{
    assert(pScene);

    scenes.push_back(pScene);
}

void SceneManager :: draw(Window* pWindow)
{
    scenes[currentScene]->setSceneRender();

    lr.clear();
    lr.addLines(grid.getPoints(),grid.getIndices());

    lr.draw();

    scenes[currentScene]->draw(pWindow);
}

bool SceneManager :: update(const Camera& camera, Music* pMusic, unsigned int time)
{
    bool playing = true;

    playing = scenes[currentScene]->update(camera, &grid, pMusic,time);
    if ( !playing )
    {
        currentScene++;
        if ( currentScene >= scenes.size() )
        {
            return true;
        }
    }

    return false;
}
