#ifndef __SCENEMANAGER_HPP__
#define __SCENEMANAGER_HPP__

#include <vector>

#include "../Objects/Grid.hpp"

class Scene;

class Window;
class Camera;
class Music;

class SceneManager
{
    private:

        std::vector < Scene* > scenes;
        unsigned int currentScene;

        Grid grid;
        LineRenderer lr;

    public:

        SceneManager();
        ~SceneManager();

        void addScene(Scene* pScene);

        void draw(Window* pWindow);
        bool update(const Camera& camera, Music* pMusic, unsigned int time);

        Scene* getCurrentScene() { return scenes[currentScene]; }
};

#endif
