#ifndef __SCENEPARTWORLD_HPP__
#define __SCENEPARTWORLD_HPP__

#include <vector>

#include "Scene.hpp"

#include "../3D/Camera/LinearCamera.hpp"
#include "../3D/LineRenderer.hpp"
#include "../Objects/Font.hpp"

#include "../Objects/Cube.hpp"
#include "../Objects/Pyramide.hpp"
#include "../Objects/Sphere.hpp"

class Window;
class Camera;
class Particules5;
class Particules4;

class ScenePartWorld : public Scene
{
    private:

        std::vector<LinearCamera*> cams;
        unsigned int currentCam;

        std::vector<Particules4*> parts;
        std::vector<Particules5*> parts2;

        std::vector<Cube*> cubes;
        std::vector<Pyramide*> piramides;
        std::vector<Sphere*> spheres;

        unsigned int startTime;

        std::vector<Colour4> coloursList;

        void launch();

    public:

        ScenePartWorld();
        ~ScenePartWorld();

        void setSceneRender();
        void draw(Window* pWindow);
        bool update(const Camera& camera, Grid* pGrid, Music* pMusic, unsigned int time);
};

#endif
