#include "SceneSad.hpp"

#include <GL/gl.h>

#include "../NEngine/Window.hpp"
#include "../3D/Camera/Camera.hpp"
#include "../3D/LineRenderer.hpp"
#include "../Objects/Particules.hpp"

SceneSad :: SceneSad():currentCam(0),f(Colour4(0.7,0.0,0.0,0.7)),startTime(0),step(0)
{
    cams.push_back(new LinearCamera(Vector3f(38,4,34),Vector3f(34,4,34),Vector3f(36,0,37),Vector3f(34,0,36),Vector3f(0,1,0), 2820));
    cams.push_back(new LinearCamera(Vector3f(44,4,34),Vector3f(41,4,34),Vector3f(38,0,37),Vector3f(41,0,36),Vector3f(0,1,0), 2820));
    cams.push_back(new LinearCamera(Vector3f(44,5,40),Vector3f(41,5,41),Vector3f(38,0,39),Vector3f(41,0,43),Vector3f(0,1,0), 2820));
    cams.push_back(new LinearCamera(Vector3f(34,5,40),Vector3f(38,5,43),Vector3f(36,0,42),Vector3f(34,0,42),Vector3f(0,1,0), 2820));
/*
    parts.push_back(new Particules(Vector3f(6,1,6),Colour4(0.0,0.74,0.19,1.0),500,0.2));
    parts.push_back(new Particules(Vector3f(6,1-0.010,6),Colour4(0.39,0.87,0.52,1.0),500,0.4));
    parts.push_back(new Particules(Vector3f(6,1-0.02,6),Colour4(0.19,0.086,0.72,1.0),500,0.6));
    parts.push_back(new Particules(Vector3f(6,1-0.03,6),Colour4(0.39,0.29,0.847,1.0),500,0.7));
    parts.push_back(new Particules(Vector3f(6,1-0.04,6),Colour4(1.0,0.8,0.0,1.0),500,0.9));
    parts.push_back(new Particules(Vector3f(6,1-0.05,6),Colour4(1.0,0.11,0.0,1.0),500,1.1));
*/
}

SceneSad :: ~SceneSad()
{
/*
    for ( std::vector<Particules*>::iterator itParts = parts.begin() ; itParts != parts.end() ; ++itParts )
    {
        delete (*itParts);
    }
*/
    for ( std::vector<LinearCamera*>::iterator itPLC = cams.begin() ; itPLC != cams.end() ; ++itPLC )
    {
        delete (*itPLC);
    }
}

void SceneSad :: setSceneRender()
{
    cams[currentCam]->apply();
}

void SceneSad :: draw(Window* pWindow)
{
    if ( step == 0 )
    {
        f.drawText(Vector3f(36,1,36),"Adinpsz",0.3);
    }
    else if ( step == 1 )
    {
        f.drawText(Vector3f(42,1,36),"Presents",0.3);
    }
    else if ( step == 2 )
    {
        f.drawText(Vector3f(42,1,42),"A new demo",0.3);
    }
    else if ( step == 3 )
    {
        f.drawText(Vector3f(36,1,42),"Flawed",0.4);
    }
/*
    glDisable(GL_DEPTH_TEST);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE);

    for ( std::vector<Particules*>::iterator itParts = parts.begin() ; itParts != parts.end() ; ++itParts )
    {
        (*itParts)->draw();
    }

    glDisable(GL_BLEND);
    glEnable(GL_DEPTH_TEST);
*/
}

bool SceneSad :: update(const Camera& camera, Grid* pGrid, Music* pMusic, unsigned int time)
{
/*
    for ( std::vector<Particules*>::iterator itParts = parts.begin() ; itParts != parts.end() ; ++itParts )
    {
        (*itParts)->update();
    }
*/
    if ( startTime == 0 )
    {
        startTime = time;
    }

    bool isNextCamera = cams[currentCam]->update(time);
    if ( isNextCamera == false )
    {
        currentCam++;
        step++;
        if ( currentCam >= cams.size() )
        {
            fadeValue = 0;
            return false;
        }
    }

    unsigned int camTime = (time - startTime) % 2820;
    if ( camTime < 500 )
    {
        fadeValue = camTime / 500.0f;
    }
    else if ( camTime > (2820 - 2250) )
    {
        fadeValue = (2820 - camTime) / 2250.0f;
    }

    return true;
}
