#ifndef __SCENESADSPECTRUM_HPP__
#define __SCENESADSPECTRUM_HPP__

#include <vector>

#include "Scene.hpp"

#include "../3D/Camera/LinearCamera.hpp"
#include "../3D/LineRenderer.hpp"
#include "../Objects/Font.hpp"

class Window;
class Camera;

class SceneSadSpectrum : public Scene
{
    private:

        std::vector<LinearCamera*> cams;
        unsigned int currentCam;

        Font f;

        unsigned int startTime;
        unsigned int step;

    public:

        SceneSadSpectrum();
        ~SceneSadSpectrum();

        void setSceneRender();
        void draw(Window* pWindow);
        bool update(const Camera& camera, Grid* pGrid, Music* pMusic, unsigned int time);
};

#endif
