#include "SceneSadSpectrumGreet.hpp"

#include <GL/gl.h>

#include "../NEngine/Window.hpp"
#include "../3D/Camera/Camera.hpp"
#include "../3D/LineRenderer.hpp"
#include "../Objects/Grid.hpp"
#include "../Music/Music.hpp"

SceneSadSpectrumGreet :: SceneSadSpectrumGreet():currentCam(0),f(Colour4(0.9,0.9,0.9,0.7)),startTime(0),step(0)
{
    cams.push_back(new LinearCamera(Vector3f(50,50,50),Vector3f(50,80,50),Vector3f(50.01,0,50.01),Vector3f(50.01,0,50.01),Vector3f(0,1,0), 2790 + 2790 + 2790 + 2790 + 2790 + 2790 + 2790));
}

SceneSadSpectrumGreet :: ~SceneSadSpectrumGreet()
{
    for ( std::vector<LinearCamera*>::iterator itPLC = cams.begin() ; itPLC != cams.end() ; ++itPLC )
    {
        delete (*itPLC);
    }
}

void SceneSadSpectrumGreet :: setSceneRender()
{
    cams[currentCam]->apply();
}

void SceneSadSpectrumGreet :: draw(Window* pWindow)
{
    if ( step > 0 )
    {
        f.drawText(Vector3f(45,1,50),"Popsy team",1.0);
    }

    if ( step > 1 )
    {
        f.drawText(Vector3f(43,1,47),"Rebels",1.0);
    }

    if ( step > 2 )
    {
        f.drawText2(Vector3f(72,1,52),"DreamDealers",1.5);
    }

    if ( step > 3 )
    {
        f.drawText2(Vector3f(66,1,59),"Frequency",1.7);
    }

    if ( step > 4 )
    {
        f.drawText2(Vector3f(64,1,33),"NoooN",1.7);
    }

    if ( step > 5 )
    {
        f.drawText2(Vector3f(58,1,33),"X men",1.7);
    }

    if ( step > 6 )
    {
        f.drawText(Vector3f(54,1,76),"Sector ONE",1.8);
    }
}

bool SceneSadSpectrumGreet :: update(const Camera& camera, Grid* pGrid, Music* pMusic, unsigned int time)
{
    static Colour4 blinkColour(0.0,0.0,0.0,0.7);

    if ( startTime == 0 )
    {
        startTime = time;
        return true;
    }

    bool isNextCamera = cams[currentCam]->update(time);
    if ( isNextCamera == false )
    {
        currentCam++;
        if ( currentCam >= cams.size() )
        {
            fadeValue = 0;
            pGrid->clearColour();
            return false;
        }
    }

    unsigned int camTime = (time - startTime);
    if ( camTime < 500 )
    {
        fadeValue = camTime / 500.0f;
    }

    static float spectrum[512] = { 0 };
    static float fakespectrum[512] = { 0 };
    pMusic->getSpectrum(spectrum,512);

    // pGrid->updateSpectrum(fakespectrum,512);
    pGrid->clearElevation();

    if ( step == 0 && camTime > 0 )
    {
        static bool trigger = false;

        if ( trigger == false )
        {
            //pGrid->makeImpulsion(32,26,blinkColour,1,9);
            trigger = true;
        }
        else if ( camTime > 0 /*+ 200*/ )
        {
            step = 1;
        }
    }

    if ( step == 1 && camTime >  2790 )
    {
        static bool trigger = false;

        if ( trigger == false )
        {
            //pGrid->makeImpulsion(32,26,blinkColour,1,9);
            trigger = true;
        }
        else if ( camTime > 2790 /*+ 200*/ )
        {
            step = 2;
        }
    }

    if ( step == 2 && camTime >  2790 + 2790 )
    {
        static bool trigger = false;

        if ( trigger == false )
        {
            //pGrid->makeImpulsion(42,46,blinkColour,1,9);
            trigger = true;
        }
        else if ( camTime > 2790 + 2790 /*+ 200*/ )
        {
            step = 3;
        }
    }

    if ( step == 3 && camTime > 2790 + 2790 + 2790 )
    {
        static bool trigger = false;

        if ( trigger == false )
        {
            //pGrid->makeImpulsion(42,46,blinkColour,1,9);
            trigger = true;
        }
        else if ( camTime >  2790 + 2790 + 2790 /*+ 200*/ )
        {
            step = 4;
        }
    }

    if ( step == 4 && camTime > 2790 + 2790 + 2790 + 2790 )
    {
        static bool trigger = false;

        if ( trigger == false )
        {
            //pGrid->makeImpulsion(25,40,blinkColour,1,11);
            trigger = true;
        }
        else if ( camTime > 2790 + 2790 + 2790 + 2790 /*+ 200*/ )
        {
            step = 5;
        }
    }

    if ( step == 5 && camTime >  2790 + 2790 + 2790 + 2790 + 2790 )
    {
        static bool trigger = false;

        if ( trigger == false )
        {
            //pGrid->makeImpulsion(25,40,blinkColour,1,11);
            trigger = true;
        }
        else if ( camTime > 2790 + 2790 + 2790 + 2790 + 2790 /*+ 200*/ )
        {
            step = 6;
        }
    }

    if ( step == 6 && camTime >  2790 + 2790 + 2790 + 2790 + 2790 + 2790 )
    {
        static bool trigger = false;

        if ( trigger == false )
        {
            //pGrid->makeImpulsion(50,36,blinkColour,1,11);
            trigger = true;
        }
        else if ( camTime > 2790 + 2790 + 2790 + 2790 + 2790 + 2790 /*+ 200*/ )
        {
            step = 7;
        }
    }


    pGrid->updateImpulsion();

    return true;
}
