#ifndef __MATHUTILS_HPP__
#define __MATHUTILS_HPP__

#include <string>
#include <exception>

static const double PI = 3.14159265;
class MathUtils
{
    public:

        static float degToRan(float angle)
        {
            const static double pi180 = PI / 180.0;
            return angle * pi180;
        }

        template <typename T>
        static T lerp(T t1, T t2, float t)
        {
            return t1 * (1 - t) + t2 * t;
        }
};

#endif
