#include "Settings.hpp"

#include <fstream>
#include <iostream>

Settings :: Settings(const std::string& fileName)
{
    std::ifstream settingFile(fileName.c_str());
    if ( settingFile.is_open() != true )
    {
        std::cerr << "Fail to open the setting file" << std::endl;
        return;
    }

    while ( !settingFile.eof() )
    {
        std::string settingName;
        float value;

        settingFile >> settingName >> value;

        settings[settingName] = value;
    }

    settingFile.close();
}

float Settings :: getSetting(const std::string& settingName, float defaultValue)
{
    if ( settings.find(settingName) != settings.end() )
    {
        return settings[settingName];
    }

    return defaultValue;
}
